天天看點

poj 2923 Relocation 狀壓DP

Relocation
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 2906 Accepted: 1170

Description

Emma and Eric are moving to their new house they bought after returning from their honeymoon. Fortunately, they have a few friends helping them relocate. To move the furniture, they only have two compact cars, which complicates everything a bit. Since the furniture does not fit into the cars, Eric wants to put them on top of the cars. However, both cars only support a certain weight on their roof, so they will have to do several trips to transport everything. The schedule for the move is planed like this:

  1. At their old place, they will put furniture on both cars.
  2. Then, they will drive to their new place with the two cars and carry the furniture upstairs.
  3. Finally, everybody will return to their old place and the process continues until everything is moved to the new place.

Note, that the group is always staying together so that they can have more fun and nobody feels lonely. Since the distance between the houses is quite large, Eric wants to make as few trips as possible.

Given the weights wi of each individual piece of furniture and the capacities C1 and C2 of the two cars, how many trips to the new house does the party have to make to move all the furniture? If a car has capacity C, the sum of the weights of all the furniture it loads for one trip can be at most C.

Input

The first line contains the number of scenarios. Each scenario consists of one line containing three numbers n, C1 and C2. C1 and C2 are the capacities of the cars (1 ≤ Ci≤ 100) and n is the number of pieces of furniture (1 ≤ n ≤ 10). The following line will contain n integers w1, …, wn, the weights of the furniture (1 ≤ wi ≤ 100). It is guaranteed that each piece of furniture can be loaded by at least one of the two cars.

Output

The output for every scenario begins with a line containing “Scenario #i:”, where i is the number of the scenario starting at 1. Then print a single line with the number of trips to the new house they have to make to move all the furniture. Terminate each scenario with a blank line.

Sample Input

2
6 12 13
3 9 13 3 10 11
7 1 100
1 2 33 50 50 67 98      
Sample Output
Scenario #1:
2

Scenario #2:
3      

Source

TUD Programming Contest 2006, Darmstadt, Germany

[Submit]   [Go Back]   [Status]   [Discuss]

第三次做此題,第一次還是小白什麼都不會,看題解。

第二次用記憶化亂搞,AC了

覺得這一次的思考是最靠譜的,給我一個起點和終點狀态,勞資就能狀态轉移!!!! -------2015

現在來看,這個做法枚舉子集的狀态已經很過時了,可以直接用for枚舉 狀态壓縮的狀态-------2016

#include<cstdio>
#include<string>
#include<cstring>
#include<iostream>
#include<cmath>
#include<algorithm>
#include<climits>
#include<queue>
#include<vector>
#include<map>
#include<sstream>
#include<set>
#include<stack>
#include<cctype>
#include<utility>
#pragma comment(linker, "/STACK:102400000,102400000")
#define PI (4.0*atan(1.0))
#define eps 1e-10
#define sqr(x) ((x)*(x))
#define FOR0(i,n)  for(int i=0 ;i<(n) ;i++)
#define FOR1(i,n)  for(int i=1 ;i<=(n) ;i++)
#define FORD(i,n)  for(int i=(n) ;i>=0 ;i--)
#define  lson   ind<<1,le,mid
#define rson    ind<<1|1,mid+1,ri
#define MID   int mid=(le+ri)>>1
#define zero(x)((x>0? x:-x)<1e-15)
#define mk    make_pair
#define _f     first
#define _s     second
#define  ysk(x)   (1<<x)
using namespace std;
//const int INF=    ;
typedef long long ll;
//const ll inf =1000000000000000;//1e15;
//ifstream fin("input.txt");
//ofstream fout("output.txt");
//fin.close();
//fout.close();
//freopen("a.in","r",stdin);
//freopen("a.out","w",stdout);
const int INF =0x3f3f3f3f;
const int maxn=  10+5 ;
//const int maxm=    ;
int n;

int V1,V2,v[maxn];
int   a1[2048];
int   a2[2048];
int   dp[2048];
int    ed;
int cnt1,cnt2;



set<int>se;
void dfs(int step,int num,int cost)
{
    if(step==n)
    {
        if(cost<=V1)      a1[++cnt1]=num;
        if(cost<=V2)      a2[++cnt2]=num;
        return;
    }
    if(cost>max(V1,V2))  return;
    dfs(step+1,num|ysk(step),cost+v[step]);

    dfs(step+1,num,cost);
}


void pre()
{
    se.clear();
    for(int p1=1;p1<=cnt1;p1++)
    {
        for(int p2=1;p2<=cnt2;p2++)
        {
           if( a1[p1]&a2[p2]  )    continue;
            se.insert( (a1[p1]|a2[p2])  );
        }
    }
}
int main()
{
    int T,kase=0;
    scanf("%d",&T);
    while(T--)
    {

        scanf("%d%d%d",&n,&V1,&V2);
        for(int i=0;i<n;i++)
            scanf("%d",&v[i]);
        printf("Scenario #%d:\n",++kase);
        cnt1=cnt2=0;
        dfs(0,0,0);

        ed=ysk(n)-1;
        pre();

        memset(dp,0x3f,sizeof dp);
        dp[0]=0;
        for(int s=0;s<=ed;s++  )
        {
            for(set<int > ::iterator it=se.begin();it!=se.end();it++ )
            {
                int x=*it;
                if( x&s )  continue;
                dp[x|s]=min(dp[x|s],dp[s]+1);
            }


        }
        printf("%d\n",dp[ed]);
        if(T)  putchar('\n');


    }


    return 0;
}
           

網上說,可以直接枚舉狀态,看這些狀态能否一次運走。再進行DP。

我是先用dfs找出每個車子能裝的物品集合,然後将兩個集合歸并、去重,這就是每個狀态的決策。再DP。